typedef union {
	struct {
		BYTE	blue;
		BYTE	green;
		BYTE	red;
		BYTE	flag;
	} b;
	DWORD	d;
} PALETTE_TABLE;

#define	START_PAL		0x0a
#define	USE_PALS		0xc0
#define	START_EXT		(START_PAL + USE_PALS)
#define	EXT_PALS		0x28
#define	TOTAL_PALS		(USE_PALS + EXT_PALS)

#define	SCMD_USEPAL			8

#define	SCMD_WINDOW8		(3 | SCMD_USEPAL)
#define	SCMD_WINDOW16		(2)
#define	SCMD_WINDOW24		(1)
#define	SCMD_WINDOW32		(0)
#define	SCMD_FULLSCREEN		(4 | SCMD_USEPAL)

extern	PALETTE_TABLE	xm_palette[];
extern	BYTE			screenmap[];
extern	BYTE			renewalline[];
extern	BYTE			x2mode;

void xm_initwindowsize(WORD width, WORD height);
void xm_windowstats(BYTE winflg);

void xm_xmilsystempal(void);
void xm_xmilsyspalset(PALETTE_TABLE *degpal);

void ddraws_init(void);
int xm_InitDirectDraw(void);
void xm_TermDirectDraw(void);

void scrn_draws(void);
void scrn_drawall(void);
void scrn_palette(void);
void change_palette(void);
void change_xmode(BYTE x2flag);

void mx_topwinui(void);
void mx_clearwinui(void);
void ddraws_redraw(void);
void change_drawlines(DWORD lines);
BYTE scrn_restore(void);

BYTE scrn_draw1(DWORD linepos);
